console.log("Injecting externally_connectable content script into", window.location.href);

// Define the API subset provided to the webpage
var externallyConnectable = {
  runtime: {
    sendMessage: function(msg) {
      console.log(msg);
        
      if (typeof msg == "function" || arguments.length > 1) {
        return window.Promise.reject(new window.Error("Invalid sendMessage params"));
      }

      // Return a Promise instance created from window.Promise.
      return new window.Promise(function(resolve, reject) {
        browser.runtime.sendMessage({
          contentMessage: msg,
        }).then(function (result) {
          if (result.errorMessageReply) {
                reject(cloneInto(result.errorMessageReply, window));
          } else {
              if (result.contentMessageReply) {
                  resolve(cloneInto(result.contentMessageReply, window));
              } else {
                  resolve();
              }
          }
        }).catch(function (err) {
          console.error("externally_connectable_contentscript runtime.sendMessage error", err);
          reject(new window.Error("Unexpected error on runtime.sendMessage"));
        });
      });
    }
  },
};

// Inject the API in the webpage wrapped by this content script
// (exposed as `browser.runtime.sendMessage({anyProp: "anyValue"}).then(reply => ..., err => ...)`)
window.wrappedJSObject.browser = cloneInto(externallyConnectable, window, {
  cloneFunctions: true,
});